"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __asyncValues = (this && this.__asyncValues) || function (o) {
    if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
    var m = o[Symbol.asyncIterator], i;
    return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
    function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
    function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.httpHandler = void 0;
var json_stream_1 = require("../json-stream");
var supportsWebStreams = (typeof globalThis.ReadableStream !== 'undefined'
    && typeof globalThis.TextDecoder !== 'undefined');
var handleFetchStreamResponse = function (response, write, close) { return __awaiter(void 0, void 0, void 0, function () {
    var textDecoder, _a, _b, chunk, e_1_1, reader, result;
    var e_1, _c;
    var _d;
    return __generator(this, function (_e) {
        switch (_e.label) {
            case 0:
                if (!(response.status === 207)) return [3 /*break*/, 16];
                textDecoder = new TextDecoder();
                if (!(response.body && response.body[Symbol.asyncIterator])) return [3 /*break*/, 13];
                _e.label = 1;
            case 1:
                _e.trys.push([1, 6, 7, 12]);
                _a = __asyncValues(response.body);
                _e.label = 2;
            case 2: return [4 /*yield*/, _a.next()];
            case 3:
                if (!(_b = _e.sent(), !_b.done)) return [3 /*break*/, 5];
                chunk = _b.value;
                write(textDecoder.decode(chunk));
                _e.label = 4;
            case 4: return [3 /*break*/, 2];
            case 5: return [3 /*break*/, 12];
            case 6:
                e_1_1 = _e.sent();
                e_1 = { error: e_1_1 };
                return [3 /*break*/, 12];
            case 7:
                _e.trys.push([7, , 10, 11]);
                if (!(_b && !_b.done && (_c = _a.return))) return [3 /*break*/, 9];
                return [4 /*yield*/, _c.call(_a)];
            case 8:
                _e.sent();
                _e.label = 9;
            case 9: return [3 /*break*/, 11];
            case 10:
                if (e_1) throw e_1.error;
                return [7 /*endfinally*/];
            case 11: return [7 /*endfinally*/];
            case 12:
                close();
                return [3 /*break*/, 16];
            case 13:
                reader = (_d = response.body) === null || _d === void 0 ? void 0 : _d.getReader();
                _e.label = 14;
            case 14:
                if (!true) return [3 /*break*/, 16];
                return [4 /*yield*/, (reader === null || reader === void 0 ? void 0 : reader.read())];
            case 15:
                result = _e.sent();
                if (result.done) {
                    close();
                    return [2 /*return*/];
                }
                write(textDecoder.decode(result.value));
                return [3 /*break*/, 14];
            case 16: return [2 /*return*/];
        }
    });
}); };
var handleFetchNoStreamResponse = function (response, write, close) {
    if (response.status === 207) {
        response.text().then(function (json) {
            write(json);
            close();
        });
    }
};
var handleFetchResponse = (supportsWebStreams
    ? handleFetchStreamResponse
    : handleFetchNoStreamResponse);
/** Create an client HTTP handler that works as a link between Client and HTTP */
var httpHandler = function (_config) {
    if (_config === void 0) { _config = {}; }
    var url = 'http://localhost/';
    var globalFetch;
    if (globalThis && globalThis.location) {
        url = globalThis.location;
        globalFetch = globalThis.fetch;
    }
    var config = __assign({ url: url, fetch: globalFetch }, _config);
    return function (iface) {
        var payload = '';
        var requests = iface.getRequests();
        var write = iface.write, end = iface.end;
        var url = config.url, fetch = config.fetch;
        var headers = {
            'Content-Type': 'text/plain;charset=utf-8',
            'Supports-Web-Streams': supportsWebStreams ? '1' : '0',
        };
        var strigifier = (0, json_stream_1.createStringifier)({
            onData: function (str) { return payload += str; }
        });
        requests.forEach(function (r) { return strigifier.write(r); });
        var parser = (0, json_stream_1.createParser)({
            onData: write,
            onClose: function () { return end(); },
            onError: function (err, str) {
                console.log("".concat(str, " ").concat(err.stack));
            },
        });
        fetch(url, { method: 'POST', headers: headers, body: payload }).then(function (response) {
            handleFetchResponse(response, parser.write, parser.close);
        }).catch(function (err) {
            // TODO: handle network error
            end(err);
            console.log(err);
        });
    };
};
exports.httpHandler = httpHandler;
//# sourceMappingURL=http.js.map